capnpc.ekam-rule 2.09 KB
Newer Older
1 2
#! /bin/sh

Kenton Varda's avatar
Kenton Varda committed
3 4
# Copyright (c) 2013-2014 Sandstorm Development Group, Inc. and contributors
# Licensed under the MIT License:
5
#
Kenton Varda's avatar
Kenton Varda committed
6 7 8 9 10 11
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
12
#
Kenton Varda's avatar
Kenton Varda committed
13 14
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
15
#
Kenton Varda's avatar
Kenton Varda committed
16 17 18 19 20 21 22
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
23 24 25 26 27 28 29 30 31 32

set -eu

if test $# = 0; then
  echo trigger filetype:.capnp
  exit 0
fi

INPUT=$1

33 34 35
case "$INPUT" in
    *capnp/c++.capnp | \
    *capnp/schema.capnp | \
36
    *capnp/rpc.capnp | \
37
    *capnp/rpc-twoparty.capnp | \
Kenton Varda's avatar
Kenton Varda committed
38
    *capnp/persistent.capnp | \
39
    *capnp/compiler/lexer.capnp | \
Kenton Varda's avatar
Kenton Varda committed
40 41
    *capnp/compiler/grammar.capnp | \
    *capnp/compat/json.capnp )
42 43 44 45
        exit 0
        ;;
esac

46 47 48 49 50 51 52 53
echo findProvider special:ekam-interceptor
read INTERCEPTOR

if test "$INTERCEPTOR" = ""; then
  echo "error:  couldn't find intercept.so." >&2
  exit 1
fi

54
echo findProvider file:compiler/capnp
55 56 57 58 59 60 61 62 63
read CAPNP

if test "$CAPNP" = ""; then
  echo "error:  couldn't find capnp." >&2
  exit 1
fi

echo findProvider file:capnpc-c++
read CAPNPC_CXX
64

65 66 67
if test "$CAPNPC_CXX" = ""; then
  echo "error:  couldn't find capnpc-c++." >&2
  exit 1
68 69 70
fi

LD_PRELOAD=$INTERCEPTOR DYLD_FORCE_FLAT_NAMESPACE= DYLD_INSERT_LIBRARIES=$INTERCEPTOR \
71
$CAPNP compile -I. -o$CAPNPC_CXX "$INPUT" 3>&1 4<&0 >&2